import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A rocket that can be controlled by the arrowkeys: up, left, right.
 * The gun is fired by hitting the 'space' key. 'z' releases a proton wave.
 
   * @Student Author kara Smith
     * 11/5/13
 * @author Poul Henriksen
 * @author Michael Kolling
   * 
 * @version 1.0
 */
public class Rocket extends SmoothMover
{
    private static final int gunReloadTime = 5;         // The minimum delay between firing the gun.

    private int reloadDelayCount;               // How long ago we fired the gun the last time.
    
    private GreenfootImage rocket = new GreenfootImage("rocket.png");    
    private GreenfootImage rocketWithThrust = new GreenfootImage("rocketWithThrust.png");
    public boolean boosterOn;

    /**
     * Initilise this rocket.
     */
    public Rocket()
    {
        reloadDelayCount = 7;
    }

    /**
     * Do what a rocket's gotta do. (Which is: mostly flying about, and turning,
     * accelerating and shooting when the right keys are pressed.)
     */
    public void act()
    {
        checkKeys();
        reloadDelayCount++;
        drift();
        ignite();
        checkCollision();
    }
    
    /**
     * Check whether there are any key pressed and react to them.
     */
    private void checkKeys() 
    {
        if (Greenfoot.isKeyDown("space")) 
        {
            fire();
        }
        
         if ( Greenfoot.isKeyDown("left"))
        
          {  turn(-5);}
        
        if ( Greenfoot.isKeyDown("right"))
        {
            turn(5);
        }
    }
    
        /**
         * 
         */
        public void ignite()
          {
            if (Greenfoot.isKeyDown("up") && !boosterOn)
          {
          boosterOn = true;
          setImage("rocketWithThrust.png");
          
         }
         if( !Greenfoot.isKeyDown("up") && boosterOn)
         {
          boosterOn = false;
          setImage("rocket.png");
            }
        }
    
    
    private void checkCollision()
    {
        Actor a = getOneIntersectingObject(Asteroid.class);
        if(a != null)
        {
        Space space = (Space) getWorld();   
        World world = getWorld();
        world.addObject(new Explosion(), getX(), getY());
        world.removeObject(this);//get rid of the rocket
        space.gameOver();
    }
    }
    
    
    
    /**
     * Fire a bullet if the gun is ready.
     */
    private void fire() 
    {
        if (reloadDelayCount >= gunReloadTime) 
        {
            Bullet bullet = new Bullet (getMovement().copy(), getRotation());
            getWorld().addObject (bullet, getX(), getY());
            bullet.move ();
            reloadDelayCount = 5;
        }
    }
    
    
    
}